
#include <stdlib.mqh>


#property  indicator_chart_window

extern   double            DaysBack       = 40;
         double            idxLow,idxHigh,day;
         int               candles,prevCandle,bar;
         double            DigitsMulti,adj,tph,tpl;
         string            DOW[]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
         bool              done;
         string            cmt;
         double            lows,highs,totLow,totHigh,avgHiLo;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
      Comment("");
      if (Digits==3||Digits == 5) DigitsMulti = 10;else DigitsMulti=1;
      adj=DigitsMulti*Point;
      
      ////////  GET SETTINGS FOR BROKER  ////////
      Print("lotsize ",MarketInfo(Symbol(),MODE_LOTSIZE));
      Print("lotstep ",MarketInfo(Symbol(),MODE_LOTSTEP));
      Print("minlot ",MarketInfo(Symbol(),MODE_MINLOT));
      Print("maxlot ",MarketInfo(Symbol(),MODE_MAXLOT));
      Print("stoplevel ",MarketInfo(Symbol(),MODE_STOPLEVEL));   
      ///////////////////////////////////////////
      for(int i=0;i<10000;i++)
      {
         ObjectDelete("hi"+i);
         ObjectDelete("lo"+i);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      for(int i=0;i<10000;i++)
      {
         ObjectDelete("hi"+i);
         ObjectDelete("lo"+i);
      }
   Comment("");
//----
   return(0);
  }
  
int start() 
   {   
         cmt="";
         day=0;
         candles=0;
         tph=0;
         tpl=0;
         for(int q=0;q<100000;q++)
         {
            candles++;
            if(TimeDayOfWeek(Time[q])!=0 && TimeDayOfWeek(Time[q])!=6 && TimeDayOfWeek(Time[q])!=TimeDayOfWeek(Time[q+1]))
            {
               day++;
               cmt=cmt+"\nday "+day+" q "+q+" "+TimeDayOfWeek(Time[q]);
            }
            if(day>=DaysBack || Time[q]==0){cmt=cmt+"\n"+TimeToStr(Time[q-1]);break;}
         }   
        
         lows=0;
         highs=0;
         totLow=0;
         totHigh=0;
         
         for(int i=candles;i>=0;i--)
         {
            if(TimeDayOfWeek(Time[i])!=0 && TimeDayOfWeek(Time[i])!=6)
            {
            
               if(Low[i]!=0 && Low[i+1]!=0 && Low[i]<Low[i+1])
               {
                  if(TimeDayOfWeek(Time[i+1])==0)
                  {
                     totLow+=Low[i+2]-Low[i];lows++;
                     tpl=(Low[i+2]-Low[i])/adj;
                     
                     if(!done)MakeText("lo"+i,tpl,Time[i], Low[i]);
                     else if(i==0)MakeText("lo"+Bars,tpl,Time[i], Low[i]);
                  }
                  else 
                  {
                     totLow+=Low[i+1]-Low[i];lows++;
                     tpl=(Low[i+1]-Low[i])/adj;
                     
                     if(!done)MakeText("lo"+i,tpl,Time[i], Low[i]);
                     else if(i==0)MakeText("lo"+Bars,tpl,Time[i], Low[i]);
                  }
               
               
                  }
         
               if(High[i]!=0 && High[i+1]!=0 && High[i]>High[i+1])
               {
                  if(TimeDayOfWeek(Time[i+1])==0)
                  {
                     totHigh+=High[i]-High[i+2];highs++;
                     tph=(High[i]-High[i+2])/adj;
                     
                     if(!done)MakeText("hi"+i,tph,Time[i], High[i]);
                     else if(i==0)MakeText("hi"+Bars,tph,Time[i], High[i]);
                  }
                  else 
                  {
                     totHigh+=High[i]-High[i+1];highs++;
                     tph=(High[i]-High[i+1])/adj;
                     
                     if(!done)MakeText("hi"+i,tph,Time[i], High[i]);
                     else if(i==0)MakeText("hi"+Bars,tph,Time[i], High[i]);
                  }
               }
            }
         }
         avgHiLo=(totLow+totHigh)/(lows+highs);
             
         Comment(
            //"q "+q+" cmt "+cmt
            //"\ntotLow "+DoubleToStr(totLow/adj,1)+" number of lows "+DoubleToStr(lows,1)
            //+"\ntotHigh "+DoubleToStr(totHigh/adj,1)+" number of highs "+DoubleToStr(highs,1)
            //+"\nnumber of candles in "+DoubleToStr(DaysBack,1)+" days "+candles
            "\nTakeProfit: "+DoubleToStr(NormalizeDouble(avgHiLo,Digits)/adj,1)
            +"\nATR-15M("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_M15,DaysBack*4*24,0)/adj,1)
            +"\nATR-H1("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_H1,DaysBack*24,0)/adj,1)
            +"\nATR-H4("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_H4,DaysBack*6,0)/adj,1)
            +"\nATR-D1("+DoubleToStr(DaysBack,0)+") "+DoubleToStr(
            iATR(Symbol(),PERIOD_D1,DaysBack,0)/adj,1)
         );
        
      done=true;
      
      return;
   }
            
void MakeText(string name,double tp,datetime t, double p)
{
   string text;
   if(StringFind(name,"lo")>=0)text=DOW[TimeDayOfWeek(t)]+"  "+DoubleToStr(tp,1)+"                ";
   if(StringFind(name,"hi")>=0)text="                "+DOW[TimeDayOfWeek(t)]+"  "+DoubleToStr(tph,1);
   
   ObjectCreate(name,OBJ_TEXT,0,0,0);
   ObjectSetText(name,text,7,"",Gray);
   ObjectSet(name,OBJPROP_ANGLE,90);
   ObjectMove(name,0,t,p);
}